#include "help.h"
#include "ui_help.h"

Help::Help(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Help)
{
    ui->setupUi(this);
    setWindowTitle(APPLICATION_NAME " " VERSION);



actionStang = new QAction(this);
//this->setContextMenuPolicy( Qt::ActionsContextMenu );
this->addAction(actionStang);
//actionStang->setShortcut( QKeySequence(tr("Qt::CTRL+Qt::Key_P") ));
actionStang->setShortcut(QApplication::translate("Help", "Esc", 0, QApplication::UnicodeUTF8));




connect(actionStang, SIGNAL(triggered()), this, SLOT(stang_()));


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::stringstream ss;
    int x=0, y=0, w=0, h=0;

    std::string initiera = k->getConf("help_x");
    ss.clear();
    ss << initiera;
    ss >> x;

    initiera = k->getConf("help_y");
    ss.clear();
    ss << initiera;
    ss >> y;

    initiera = k->getConf("help_w");
    ss.clear();
    ss << initiera;
    ss >> w;

    initiera = k->getConf("help_h");
    ss.clear();
    ss << initiera;
    ss >> h;

    delete k;

    layout = new QHBoxLayout;
    textedit = new QTextEdit;

    layout->addWidget(textedit);
    this->setLayout(layout);

    textedit->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    QString tmp, tmp2;
    const QString s = tr("Programs to put the time right when the camera was set incorrectly when you took the picture.<br><br>You choose a picture where you know the time and date. All other images you have opened adapted.<br><br>NOTE: Remember that the camera must have the same adjustment for the time and date on all your images.");
    const QString visaTimeedit(tr("<br><br>Set date from ")+tmp.setNum(START_YEAR)+"-01-01 00:00:00 "+tr("to ")+tmp2.setNum(STOP_YEAR)+"-12-31 23:59:59");

    textedit->insertHtml(s+visaTimeedit);
textedit->setContentsMargins(3,3,3,3);
textedit->setStyleSheet(" QTextEdit { background:white; color:black; font-size:12pt;  }");

const int ymax(QApplication::desktop()->height());
if (y > (ymax-50))
{
     y=200;
     x=200;
 }

const int xmax(QApplication::desktop()->width());
    if (x > (xmax-50))
{
     y=200;
     x=200;
 }


this->setGeometry(x,y,w,h);
textedit->setDisabled(true);

}

Help::~Help()
{
    QRect rect;
    rect=this->geometry();

    int x = rect.x();
    int y = rect.y();
    int w = rect.width();
    int h = rect.height();

    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::stringstream ss;
    std::string s;

    ss.clear();
    ss << x;
    ss >> s;
    k->setConf("help_x",s);

    ss.clear();
    ss << y;
    ss >> s;
    k->setConf("help_y",s);

    ss.clear();
    ss << w;
    ss >> s;
    k->setConf("help_w",s);

    ss.clear();
    ss << h;
    ss >> s;
    k->setConf("help_h",s);

    delete k;


    delete ui;
}

void Help::closeEvent(QCloseEvent * event)
{



delete this;

}

// SLOTS

void Help::stang_()
{
   delete this;

}

