/*
    EXIF ReGenerate
    Copyright (C) 2010 - 2011 Ingemar Ceicer
    http://ceicer.org/ingemar/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#include <QtGui/QApplication>

#include <QTranslator>
#include <QLocale>

#include "mainwindow.h"
#include "bigimage.h"
#include "config.h"
#include <string>


           // Windows
              const QString INSTALL_DIR = QDir::toNativeSeparators(QDir::currentPath()+"/");
           // Linux
           // const QString INSTALL_DIR = "/usr/local/exifregenerate/";


int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

   // QString path;
   // path = a.applicationDirPath();
   // a.addLibraryPath("C:\\Program\\EXIFReGenerate");

QTranslator translator;
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    Config *k = new Config(conf_file_name);
    std::string s = k->getConf("language");
    delete k;
    QString sprak = QString::fromStdString(s);

    if (s == "sv_SE")
    {





           translator.load(INSTALL_DIR+"exifrg_"+sprak);
           a.installTranslator(&translator);

     }

    if (s == "ru_RU")
    {





           translator.load(INSTALL_DIR+"exifrg_"+sprak);
           a.installTranslator(&translator);

     }

    if (s == "el_GR")
    {





           translator.load(INSTALL_DIR+"exifrg_"+sprak);
           a.installTranslator(&translator);

     }




    if (s  == "en_US")
    {


    }


    if (s  == "")
    {

        QString locale = QLocale::system().name();
        translator.load(INSTALL_DIR+"exifrg_"+locale);
        a.installTranslator(&translator);

    }






    MainWindow w;

    w.show();

    return a.exec();
}
